#include <windows.h>
#include <tchar.h>
#define TVTEST_PLUGIN_CLASS_IMPLEMENT
#include "TVTestPlugin.h"


// Rg[
#define REMOCON_NAME L"Android Remocon"

// {^̃Xg
static TVTest::ControllerButtonInfo g_ButtonList[] = {
	{L"{^1", L"Channel1"},
	{L"{^2", L"Channel2"},
	{L"{^3", L"Channel3"},
	{L"{^4", L"Channel4"},
	{L"{^5", L"Channel5"},
	{L"{^6", L"Channel6"},
	{L"{^7", L"Channel7"},
	{L"{^8", L"Channel8"},
	{L"{^9", L"Channel9"},
	{L"{^10", L"Channel10"},
	{L"{^11", L"Channel11"},
	{L"{^12", L"Channel12"},
	{L"{^13", NULL},
	{L"{^14", NULL},
	{L"{^15", NULL},
	{L"{^16", NULL},
	{L"{^17", NULL},
	{L"{^18", NULL},
	{L"{^19", NULL},
	{L"{^20", NULL},
	{L"{^21", NULL},
	{L"{^22", NULL},
	{L"{^23", NULL},
	{L"{^24", NULL},
	{L"{^25", NULL},
	{L"{^26", NULL},
	{L"{^27", NULL},
	{L"{^28", NULL},
	{L"{^29", NULL},
	{L"{^30", NULL},
	{L"{^31", L"Fullscreen"},
	{L"{^32", L"Mute"},
};

#define NUM_BUTTONS (sizeof(g_ButtonList)/sizeof(g_ButtonList[0]))


class CAndroidRemocon : public TVTest::CTVTestPlugin
{
	UINT m_Message;
	HANDLE m_hMap;
	void *m_pView;
	static LRESULT CALLBACK EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData);
	static BOOL CALLBACK MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
										 LRESULT *pResult,void *pClientData);
public:
	CAndroidRemocon();
	virtual bool GetPluginInfo(TVTest::PluginInfo *pInfo);
	virtual bool Initialize();
	virtual bool Finalize();
};

CAndroidRemocon::CAndroidRemocon()
	: m_hMap(NULL)
	, m_pView(NULL)
{
}

bool CAndroidRemocon::GetPluginInfo(TVTest::PluginInfo *pInfo)
{
	// vOC̏Ԃ
	pInfo->Type           = TVTest::PLUGIN_TYPE_NORMAL;
	pInfo->Flags          = 0;
	pInfo->pszPluginName  = L"Android Remocon";
	pInfo->pszCopyright   = L"Public Domain";
	pInfo->pszDescription = L"Android[ő\";
	return true;
}

bool CAndroidRemocon::Initialize()
{
	m_Message = 0;
	// Rg[̓o^
	TVTest::ControllerInfo Info;
	Info.Flags             = 0;
	Info.pszName           = REMOCON_NAME;
	Info.pszText           = L"AndroidR";
	Info.NumButtons        = NUM_BUTTONS;
	Info.pButtonList       = g_ButtonList;
	Info.pszIniFileName    = NULL;
	Info.pszSectionName    = L"AndroidRemocon";
	Info.ControllerImageID = 0;
	Info.SelButtonsImageID = 0;
	Info.pTranslateMessage = NULL;
	Info.pClientData       = NULL;
	if (!m_pApp->RegisterController(&Info)) {
		m_pApp->AddLog(L"Rg[o^ł܂B");
		return false;
	}
	m_pApp->SetEventCallback(EventCallback,this);
	return true;
}

bool CAndroidRemocon::Finalize()
{
	return true;
}


LRESULT CALLBACK CAndroidRemocon::EventCallback(UINT Event,LPARAM lParam1,LPARAM lParam2,void *pClientData)
{
	CAndroidRemocon* pThis=static_cast<CAndroidRemocon*>(pClientData);
	
	switch (Event)
	{
	case TVTest::EVENT_PLUGINENABLE:
		if (lParam1!=0)
		{
			if (pThis->m_Message == 0)
			{
				pThis->m_Message=::RegisterWindowMessage("AndroidRemocon");
			}
			if (pThis->m_Message != 0)
			{
				pThis->m_pApp->SetWindowMessageCallback(MessageCallback,pThis);
				if (pThis->m_hMap == NULL)
				{
					pThis->m_hMap=::CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, 1024 * 16, TEXT("AndroidRemocon SharedMemory"));
					pThis->m_pView = ::MapViewOfFile(pThis->m_hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
				}
			}
			else
			{
				pThis->m_pApp->AddLog(L"ŃG[܂B");
				return FALSE;
			}
		}
		else
		{
			pThis->m_pApp->SetWindowMessageCallback(NULL);
			::UnmapViewOfFile(pThis->m_pView);
			::CloseHandle(pThis->m_hMap);
			pThis->m_pView = NULL;
			pThis->m_hMap = NULL;
		}
		return TRUE;
	}
	return 0;
}

BOOL CALLBACK CAndroidRemocon::MessageCallback(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam,
											LRESULT *pResult,void *pClientData)
{
	CAndroidRemocon* pThis=static_cast<CAndroidRemocon*>(pClientData);
	if (uMsg == pThis->m_Message)
	{
		int* param = (int*)pThis->m_pView;
		*pResult = 0;
		switch (wParam)
		{
		case 1:
			pThis->m_pApp->OnControllerButtonDown(REMOCON_NAME, lParam);
			break;
		case 2:
			*pResult = pThis->m_pApp->Close();
			break;
		case 3:
			*pResult = pThis->m_pApp->SetDriverName((LPCWSTR)pThis->m_pView);
			break;
		case 4:
			*pResult = pThis->m_pApp->GetDriverFullPathName((LPWSTR)pThis->m_pView, MAX_PATH);
			break;
		case 5:
			*pResult = pThis->m_pApp->SetChannel(param[0], param[1]);
			break;
		case 6:
			*pResult = pThis->m_pApp->SetVolume(lParam);
		}
		return TRUE;
	}
	return FALSE;
}

// vOCNX̃CX^X𐶐
TVTest::CTVTestPlugin *CreatePluginClass()
{
	return new CAndroidRemocon;
}